=== modified file 'lib/canonical/configure.zcml'
--- lib/canonical/configure.zcml	2005-11-17 21:44:26 +0000
+++ lib/canonical/configure.zcml	2006-01-23 15:24:10 +0000
@@ -28,6 +28,7 @@
     <browser:skin
         name="shipit"
         interface="canonical.launchpad.layers.ShipItLayer"/>
+    <!-- Set via overrides -->
     <browser:defaultSkin
         name="launchpad" />
 

=== modified file 'lib/canonical/launchpad/mail/meta.py'
--- lib/canonical/launchpad/mail/meta.py	2005-11-04 23:08:34 +0000
+++ lib/canonical/launchpad/mail/meta.py	2006-01-23 15:24:10 +0000
@@ -90,7 +90,7 @@
            discriminator = ('utility', IMailer, name),
            callable = handler,
            args = (
-               'Utilities', 'provideUtility',
+               'provideUtility',
                IMailer, StubMailer(from_addr, [to_addr], mailer, rewrite), name,
                )
            )

=== modified file 'lib/canonical/launchpad/webapp/configure.zcml'
--- lib/canonical/launchpad/webapp/configure.zcml	2005-12-30 15:56:02 +0000
+++ lib/canonical/launchpad/webapp/configure.zcml	2006-01-23 15:24:10 +0000
@@ -4,7 +4,10 @@
     i18n_domain="canonical.launchpad">
 
     <include file="servers.zcml" />
+    <!-- Included via override-includes, as we are overriding a default
+         Z3 component
     <include file="errorlog.zcml" />
+    -->
     <include file="bug-5133.zcml" />
 
     <content class="canonical.launchpad.webapp.LaunchpadBrowserRequest">

=== modified file 'lib/canonical/launchpad/webapp/generalform.py'
--- lib/canonical/launchpad/webapp/generalform.py	2006-01-17 02:52:49 +0000
+++ lib/canonical/launchpad/webapp/generalform.py	2006-01-23 15:24:10 +0000
@@ -183,6 +183,6 @@
     if layer is None:
         layer = IBrowserRequest
 
-    s = zapi.getGlobalService(zapi.servicenames.Adapters)
-    s.register((for_, layer), Interface, name, class_)
+    sm = zapi.getGlobalSiteManager()
+    sm.provideAdapter((for_, layer), Interface, name, class_)
 

=== modified file 'lib/canonical/launchpad/webapp/meta-overrides.zcml'
--- lib/canonical/launchpad/webapp/meta-overrides.zcml	2005-10-31 18:29:12 +0000
+++ lib/canonical/launchpad/webapp/meta-overrides.zcml	2006-01-23 15:24:10 +0000
@@ -4,16 +4,6 @@
 
 <meta:directives namespace="http://namespaces.zope.org/browser">
 
-<!-- This overridden directive can be removed when Zope3 has a
-     browser:defaultView directive that allows you to specify the
-     layer for that default.
-  -->
-    <meta:directive
-        name="defaultView"
-        schema="canonical.launchpad.webapp.metazcml.IDefaultViewDirective"
-        handler="canonical.launchpad.webapp.metazcml.defaultView"
-        />
-
     <meta:directive
         name="page"
         schema="canonical.launchpad.webapp.metazcml.IPageDirective"

=== modified file 'lib/canonical/launchpad/webapp/metazcml.py'
--- lib/canonical/launchpad/webapp/metazcml.py	2006-01-19 14:33:19 +0000
+++ lib/canonical/launchpad/webapp/metazcml.py	2006-01-23 15:24:10 +0000
@@ -471,28 +471,6 @@
     original_page(_context, name, permission, for_, class_=Favicon)
 
 
-# The original defaultView directive is defined in the browser publisher code.
-# In it, the `layer` is hard-coded rather than available as an argument.
-# See zope/app/publisher/browser/metaconfigure.py.
-# `layer` here is called `type` there, but is not available as an argument.
-
-def defaultView(_context, name, for_=None, layer=IDefaultBrowserLayer):
-    type = layer
-    _context.action(
-        discriminator = ('defaultViewName', for_, type, name),
-        callable = handler,
-        args = (zope.component.servicenames.Adapters, 'register',
-                (for_, type), IDefaultViewName, '', name, _context.info)
-        )
-
-    if for_ is not None:
-        _context.action(
-            discriminator = None,
-            callable = provideInterface,
-            args = ('', for_)
-            )
-
-
 class IAssociatedWithAFacet(Interface):
     """A zcml schema for something that can be associated with a facet."""
 

=== modified file 'lib/canonical/launchpad/webapp/servers.py'
--- lib/canonical/launchpad/webapp/servers.py	2005-12-18 02:28:53 +0000
+++ lib/canonical/launchpad/webapp/servers.py	2006-01-23 15:24:10 +0000
@@ -108,11 +108,11 @@
 
     implements(ILaunchpadBrowserApplicationRequest)
 
-    def __init__(self, body_instream, outstream, environ, response=None):
+    def __init__(self, body_instream, environ, response=None):
         self.breadcrumbs = []
         self.traversed_objects = []
         super(LaunchpadBrowserRequest, self).__init__(
-            body_instream, outstream, environ, response)
+            body_instream, environ, response)
 
     @property
     def stepstogo(self):
@@ -223,12 +223,14 @@
         ## self._http = HTTPPublication(db)
         self._browser = LaunchpadBrowserPublication(db)
 
-    def __call__(self, input_stream, output_steam, env):
+    def __call__(self, input_stream, env, output_steam=None):
         """See zope.app.publication.interfaces.IPublicationRequestFactory"""
+        assert output_stream is None, 'output_stream is deprecated in Z3.2'
+
         method = env.get('REQUEST_METHOD', 'GET').upper()
 
         if method in self._browser_methods:
-            request = LaunchpadBrowserRequest(input_stream, output_steam, env)
+            request = LaunchpadBrowserRequest(input_stream, env)
             request.setPublication(self._browser)
         else:
             raise NotImplementedError()
@@ -241,11 +243,13 @@
 class DebugLayerRequestFactory(HTTPPublicationRequestFactory):
     """RequestFactory that sets the DebugLayer on a request."""
 
-    def __call__(self, input_stream, output_steam, env):
+    def __call__(self, input_stream, env, output_steam=None):
         """See zope.app.publication.interfaces.IPublicationRequestFactory"""
+        assert output_stream is None, 'output_stream is deprecated in Z3.2'
+
         # Mark the request with the 'canonical.launchpad.layers.debug' layer
         request = HTTPPublicationRequestFactory.__call__(
-            self, input_stream, output_steam, env)
+            self, input_stream, env)
         canonical.launchpad.layers.setFirstLayer(
             request, canonical.launchpad.layers.DebugLayer)
         return request

=== modified file 'override-configure-normal.zcml'
--- override-configure-normal.zcml	2005-10-31 18:29:12 +0000
+++ override-configure-normal.zcml	2006-01-23 15:24:10 +0000
@@ -1,5 +1,3 @@
 <configure xmlns="http://namespaces.zope.org/zope">
-    <include file="configs/+config-overrides.zcml" />
-    <include files="override-includes/*-configure.zcml" />
     <include files="override-includes/*-configure-normal.zcml" />
 </configure>

=== modified file 'site.zcml'
--- site.zcml	2005-10-31 18:29:12 +0000
+++ site.zcml	2006-01-23 15:24:10 +0000
@@ -1,12 +1,20 @@
 <configure xmlns="http://namespaces.zope.org/zope">
 
+    <!--
     <include file="zopeapp.zcml" />
+    -->
+    <include package="zope.app" />
 
     <!-- Session machinery -->
+    <!--
     <include file="zopeappsession.zcml" />
+    -->
 
     <!-- Browser Configurations -->
+    <!--
     <include file="zopeappbrowser.zcml" />
+    -->
+    <include package="zope.app" file="browser.zcml" />
 
     <include package="canonical" />
 
@@ -23,6 +31,7 @@
     <include files="package-includes/*-configure-normal.zcml" />
 
     <!-- Provide local overrides of standard configurations-->
+    <includeOverrides file="override-configure.zcml" />
     <includeOverrides file="override-configure-normal.zcml" />
 
     <include file="securitypolicy.zcml" />

